<?php
	$fixcontent = <<<EOT
	// Protect against external scripts execution if safe mode is not enabled
	if ( XOOPS_CHECK_PATH && !@ini_get('safe_mode') ) {
		if ( function_exists('debug_backtrace') ) {
			\$xoopsScriptPath = debug_backtrace();
			if ( !count(\$xoopsScriptPath) ) {
			 	die("XOOPS path check: this file cannot be requested directly");
			}
			\$xoopsScriptPath = \$xoopsScriptPath[0]['file'];
		} else {
			\$xoopsScriptPath = isset(\$_SERVER['PATH_TRANSLATED']) ? \$_SERVER['PATH_TRANSLATED'] :  \$_SERVER['SCRIPT_FILENAME'];
		}
		if ( DIRECTORY_SEPARATOR != '/' ) {
			// IIS6 may double the \ chars
			\$xoopsScriptPath = str_replace( strpos( \$xoopsScriptPath, '\\\\\\\\', 2 ) ? '\\\\\\\\' : DIRECTORY_SEPARATOR, '/', \$xoopsScriptPath);
		}
		if ( strcasecmp( substr(\$xoopsScriptPath, 0, strlen(XOOPS_ROOT_PATH)), str_replace( DIRECTORY_SEPARATOR, '/', XOOPS_ROOT_PATH)) ) {
		 	exit("XOOPS path check: Script is not inside XOOPS_ROOT_PATH and cannot run.");
		}
	}

EOT;





$page = @intval($_REQUEST['page']);
$path = '../mainfile.php';

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
  <title>Xoops 2.0.6 to 2.0.7 upgrade</title>
  <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />

<style type="text/css">
body {
	padding:		10px 10px;
}
h1 {
	margin:		0px;
	background:	#2F5376 url('../themes/default/logo.gif') no-repeat center left;
	color:	#ffffff;
	padding:		20px 1em 20px 160px;
	min-height:		40px;
}
#howto {
	display:	block;
	padding:	.2em .25em;
	text-align:	right;
	background-color: #cccccc;
	color:		#666666;
}
#howto:hover {
	color:		#ff6600;
}
#content {
	padding:	1em;
}
pre {
	margin:	0px;	padding:	.25em;
}
</style>

</head>
<body style="margin: 0; padding: 0;">
<form action='<?php echo $_SERVER['PHP_SELF']; ?>' method='post'>
<h1>Xoops 2.0.6 to 2.0.7 upgrade script</h1>
<a href="<?php echo $_SERVER['PHP_SELF']; ?>?page=3" id="howto">Instructions to upgrade <em>manually</em></a>
<div id="content">
<?php if ($page == 1) {
	echo "<p><strong>Checking read and write access to $path </strong>: ";
	if (!@is_file($path) || !is_readable($path) || !is_writable($path)) {
	 	echo "Failed.<br />";
	 	echo "Please ensure ../mainfile.php is writable.<br/>";
	} else {
	 	echo "OK<br />";
	}
	echo "<strong>Analyzing mainfile.php</strong>: ";
	$xoopsOption['nocommon']=1;
	$parse_ok = @include_once($path);
	if (!$parse_ok || !defined('XOOPS_ROOT_PATH')) { ?>
		Failed.<br />
		<p>You should apply this update manually.<br />
		Please follow the instructions provided on the next page.<br />
		<input type="hidden"  name="page" value="3" />
		<input type="submit" value="Continue" />
<?php
	} else {
		echo "Success.<br />";
	 	$xopath = str_replace( DIRECTORY_SEPARATOR, '/', XOOPS_ROOT_PATH);

		$xoopsPathTrans = isset($_SERVER['PATH_TRANSLATED']) ? $_SERVER['PATH_TRANSLATED'] :  $_SERVER['SCRIPT_FILENAME'];
		if ( DIRECTORY_SEPARATOR != '/' ) {
		 	// IIS6 doubles the \ chars
			$xoopsPathTrans = str_replace( strpos( $xoopsPathTrans, '\\\\', 2 ) ? '\\\\' : DIRECTORY_SEPARATOR, '/', $xoopsPathTrans);
		}
		// -- end of copy
		$xoopsPathOK = !strcasecmp( substr($xoopsPathTrans, 0, strlen(XOOPS_ROOT_PATH)), $xopath);
?>
	<strong>Recommended configuration of the security check</strong>: <?php echo $xoopsPathOK?'Enabled':'Disabled';?><br />
	</p>
	<input name="page" type="hidden" value="2" />
	<input name="state" type="hidden" value="<?php echo $xoopsPathOK?'on':'off';?>" />
	<input type="submit" value="Proceed to second stage" />
<?php
	}
} elseif ($page == 2) {
	echo "Generating new file content<br />";
 	$state = @$_REQUEST['state']=='on'?'1':'0';
	$outdefine .= "define('XOOPS_CHECK_PATH', $state);";
	$mainfile = file($path);
	$out = '';
	$fix=0;
	foreach ($mainfile as $line) {
		if (preg_match('/XOOPS_CHECK_PATH/', $line)) {
			$fix=2;
			break;
		}
 	 	$out .= $line;
		if (preg_match('/XOOPS_URL/', $line)) {
 		 	$out .= "\t$outdefine\n$fixcontent";
		 	$fix=1;
		}
	}
	if ($fix==2) {
	 	echo "File already updated.<br />";
	} elseif ($fix==1) {
		echo "Saving $path : ";
		if ($fp = @fopen($path, 'w')) {
		 	fwrite($fp, $out);
		 	fclose($fp);
		 	echo "OK <br />";
		} else {
		 	echo "Failed <br />";
		}
	} else {
	 	echo "XOOPS_URL definition not found: file not updated.<br />";
	}
	?>
	<p>The patch has been successfully applied.<br/>Once you've checked that
	<a href="../" target="_blank">your site works</a>, you should <strong>remove this upgrade script from your server</strong>.
	</p>
<?php
} elseif ($page == 3) {
?>
	<h2>Manual installation instructions</h2>
	<p>To manually modify your configuration site, please insert the following code after the definitions
	of XOOPS_ROOT_PATH and XOOPS_URL (and whatever happens, <em>before</em> the definition of any sensitive
	configuration constant like the XOOPS_DB_XXX ones:</p>
	<pre style="background-color:#dddddd;margin:0px">
	// XOOPS Virtual Path (URL)
	// Virtual path to your main XOOPS directory WITHOUT trailing slash
	define('XOOPS_URL', 'http://mydomain.com');</pre><pre style="margin:0px;padding:.5em;border:2px solid #999999;overflow:auto"><code>
<?php
	echo "\tdefine('XOOPS_CHECK_PATH', 1);\n$fixcontent";
?>
	</code></pre>
<?php
	} else { ?>
	<h2>Introduction ?</h2>
	<p>XOOPS 2.0.7 includes a new protection that prevents external scripts to get access to your site data.<br />
	This protection is not required if you run PHP in <em>safe mode</em>, but may de desired if it's not the case
	and your site is hosted in a shared environment.</p>
	<p>The required security check will be inserted in the xoops configuration file located in your site
	root folder (<em>mainfile.php</em>). If for any reason you need to bypass it, you can do so by changing the
	value of the XOOPS_CHECK_PATH constant.</p>
	<p><strong>Before proceeding:</strong>
	<ul>
	<li>Ensure you have successfully copied the whole content of this package html/ folder into your current XOOPS installation.</li>
	<li><strong style="font-size:120%">Make a backup copy of your mainfile.php file</strong></li>
	<li>Check that this script has write access to your mainfile.php</li>
	</ul>
	</p>
	<p>Also note that this script has been made to update standard mainfile.php files. If for any
	reason you have modified this file or moved it, you may want to follow the instructions to apply the update manually.</p>
	<input name="page" type="hidden" value="1" />
	<input type="submit" value="Proceed to first stage" />
<?php
}
?>
</div>
</form>
</body>
</html>